import React from 'react';
import { BrowserRouter as Router, Routes, Route } from "react-router-dom";

import Header from './components/Header';
import About from './components/About';
import Team from './components/Team';
import PrivacyMixerSection from './components/PrivacyMixerSection';
import Footer from './components/Footer';
import ReadMorePage from "./components/ReadMorePage";
import ReadMorePage2 from "./components/ReadMorePage2";  // Import the second Read More page
import AboutPage from "./components/AboutPage";

export default function App() {
  return (
    <Router>
      <div className='w-full overflow-hidden'>
        {/* Header only on the main page */}
        <Routes>
          <Route path="/" element={
            <>
              <Header />
              <About />
              <Team />
              <PrivacyMixerSection />
              <Footer />
            </>
          } />
          
          {/* Read More pages */}
          <Route path="/crypto-scam-detector" element={<ReadMorePage />} />
          <Route path="/defi-strategy-advisor" element={<ReadMorePage2 />} /> {/* New route for the second Read More page */}
          <Route path="/about" element={<AboutPage />} />

        </Routes>
      </div>
    </Router>
  );
}
