import React from "react";

export default function About() {
  return (
    <section
      className="relative flex items-center justify-center bg-[#101010] w-full min-h-screen px-6 sm:px-10 md:px-20 lg:px-32 overflow-hidden text-white"
      id="About"
    >
      <div className="absolute inset-0 z-0 bg-grid-pattern opacity-10"></div>
      <div className="relative z-10 bg-[#131313] p-6 sm:p-10 rounded-lg shadow-lg w-full max-w-7xl border border-gray-800">
        <h1 className="text-[22px] sm:text-[32px] md:text-[46px] xl:text-[60px] font-normal mb-6 text-shadow-lg text-center flex flex-wrap items-center justify-center mx-auto">
          What is
          <img
            src="/assets/logoaxali.png"
            alt="Trustify Logo"
            className="w-[120px] sm:w-[160px] md:w-[190px] xl:w-[240px] ml-2 md:mt-4 mt-2 xl:h-[80px] max-w-full"
          />
          ?
        </h1>

        {/* პირველი (ზედა) ბოქსი უცვლელად */}
        <div className="flex flex-col md:flex-row items-center justify-between gap-6 md:gap-10 mb-10 w-full">
          <div className="relative p-4 sm:p-6 rounded-lg border border-gray-800 shadow-lg flex-1 bg-[#131313] transition-colors duration-300 flex flex-col md:flex-row items-center justify-between overflow-hidden h-full">
            <div
              className="absolute top-0 left-0 w-full h-full bg-cover bg-center z-0 "
              style={{
                backgroundImage: "url('/assets/vava.png')",
              }}
            ></div>

            <div className="flex-1 text-center md:text-left relative z-10">
              <p className="text-[22px] sm:text-[25px] bg-gradient-to-r from-[#3b82f6] via-[#a8a5e6] text-transparent bg-clip-text font-semibold">
                AI for a Safer Crypto Future.
              </p>
              <h2 className="text-gray-300 text-[14px] max-w-[470px] sm:text-[16px] md:text-[18px] leading-snug font-thin">
                Trustify analyzes crypto projects, social media accounts, and websites to detect scams. It also helps users develop DeFi strategies based on their risk tolerance, investment goals, and market conditions.
              </h2>
            </div>

            <img
              src="/assets/robot.png"
              alt="Robot Illustration"
              className="w-[50%] sm:w-[40%] md:w-[50%] lg:w-[40%] xl:w-[30%] max-w-[200px] h-auto rounded-lg mt-4 md:mt-0 md:absolute md:bottom-0 md:right-0 z-10"
            />
          </div>
        </div>

        {/* ქვედა ორი ბოქსი ერთმანეთთან სიმეტრიულად */}
        <div className="grid grid-cols-1 md:grid-cols-2 gap-6 md:gap-8 w-full">
  {/* მარცხენა ბოქსი */}
  <div className="p-6 sm:p-8 rounded-lg shadow-lg bg-[#131313] border border-gray-800 transition-colors duration-300 min-h-[240px] flex flex-col justify-center items-center text-center">
    <h2 className="text-gray-300 text-[14px] sm:text-[16px] md:text-[18px] max-w-[95%] leading-relaxed font-thin">
      AI scans websites for phishing attempts and identifies fraudulent smart contracts, including rug pulls, unsafe code, and malicious behavior. It also analyzes social media platforms and forums (e.g., Twitter, Reddit, Telegram) for sentiment analysis to detect misleading promotion tactics and orchestrated campaigns by bots.
    </h2>
  </div>

  {/* მარჯვენა ბოქსი */}
  <div className="p-6 sm:p-8 rounded-lg shadow-lg bg-[#131313] border border-gray-800 transition-colors duration-300 min-h-[240px] flex flex-col justify-center items-center text-center">
    <h2 className="text-gray-300 text-[14px] sm:text-[16px] md:text-[18px] max-w-[95%] leading-relaxed font-thin">
      The DeFi Strategy Advisor helps users optimize their decentralized finance investments by providing personalized strategy recommendations. It integrates with DeFi protocols to track portfolios, yield farming, liquidity pools, staking rewards, offering insights to maximize returns, minimize risks, and adjust strategies in real-time.
    </h2>
  </div>
</div>

      </div>
    </section>
  );
}
