import React from 'react';

export default function AboutPage() {
  return (
    <div className="flex items-center justify-center min-h-screen bg-black text-white p-6">
      <div className="border border-gray-700 p-6 max-w-2xl rounded-lg shadow-lg text-left">
        <h1 className="text-4xl font-semibold mt-6 mb-3">About Us</h1>
        <p className="text-lg mb-4">
          Welcome to the future of cryptocurrency investment and security. At Trustify, we are on a mission to empower crypto investors with intelligent, data-driven tools that optimize their investments while keeping them safe from scams and market manipulation. Our platform is built on cutting-edge AI technology, designed to give you the insights, strategies, and real-time alerts you need to navigate the complex and fast-paced world of cryptocurrency.
        </p>

        <div className="mt-6">
          <h2 className="text-2xl font-semibold mb-3">Our Vision:</h2>
          <p className="text-lg">We envision a world where crypto investments are secure, informed, and transparent. As the decentralized finance (DeFi) and cryptocurrency space continues to grow, it’s essential for investors to have access to tools that help them make smarter decisions while avoiding risks.</p>
        </div>

        <div className="mt-6">
          <h2 className="text-2xl font-semibold mb-3">Our Mission:</h2>
          <p className="text-lg">To provide the highest level of protection and strategy optimization in the cryptocurrency ecosystem. We are committed to developing innovative AI-powered tools that can identify risks, detect fraud, and enhance investment decisions.</p>
        </div>

        <div className="mt-6">
          <h2 className="text-2xl font-semibold mb-3">Our Products:</h2>
          <ul className="space-y-3 mb-6">
            <li><strong>Crypto Scam Detector:</strong> AI-driven fraud detection and scam analysis.</li>
            <li><strong>DeFi Strategy Advisor:</strong> Personalized investment strategies for DeFi investors.</li>
          </ul>
        </div>

        <div className="mt-6">
          <h2 className="text-2xl font-semibold mb-3">Why Choose Us?</h2>
          <ul className="space-y-3 mb-6">
            <li><strong>Advanced AI & Real-Time Insights:</strong> Fast and reliable investment analysis.</li>
            <li><strong>Security First:</strong> Constant DeFi monitoring and fraud alerts.</li>
            <li><strong>Educational Support:</strong> Resources to help investors grow.</li>
            <li><strong>Continuous Improvement:</strong> AI models that evolve over time.</li>
          </ul>
        </div>

        <div className="mt-6">
          <h2 className="text-2xl font-semibold mb-3">Our Values:</h2>
          <ul className="space-y-3 mb-6">
            <li><strong>Trust & Transparency:</strong> Clear and honest investment guidance.</li>
            <li><strong>Innovation:</strong> Cutting-edge technology for crypto security.</li>
            <li><strong>User-Centric Design:</strong> Simple and intuitive tools.</li>
            <li><strong>Community Empowerment:</strong> Building a safer crypto ecosystem together.</li>
          </ul>
        </div>

        <p>
          At Trustify, we are passionate about creating a safer, smarter, and more efficient future for cryptocurrency investors. Whether you’re a beginner or a seasoned pro, we’re here to support your journey.
        </p>

        <br />
        <p className="font-semibold">Your trusted partner in crypto security and investment strategy.</p>
      </div>
    </div>
  );
}
