import React from 'react';
import { Link } from "react-router-dom";

export default function Footer() {
  return (
    <footer className="bg-[#080808] text-[#c1c1c1] py-10 text-sm">
      <div className="max-w-screen-xl mx-auto px-6 lg:px-16">
        <div className="flex flex-col lg:flex-row justify-between items-center">
          
          {/* Logo & Description Section */}
          <div className="text-center lg:text-left lg:pl-10">
            <img src="/assets/logoaxali.png" className="h-10 mx-auto lg:mx-0 mt-4" alt="TrustifyAI Logo" />
            <h3 className="mt-4 max-w-sm xl:text-[18px]">
              AI-powered tools for safe and secure crypto and DeFi investments.<br />
              Detect scams, maximize returns, and optimize strategies for smarter investments.
            </h3>
          </div>

          {/* Social Links - Vertical Alignment */}
          <div className="flex flex-col items-center space-y-4 mt-6 lg:mt-0 lg:pr-10">
            <a href="https://discord.com/invite/trustify" target="_blank" rel="noopener noreferrer">
              <img src="/assets/disc.png" alt="Discord" className="h-5" />
            </a>
            <a href="https://x.com/TrustifySol" target="_blank" rel="noopener noreferrer">
              <img src="/assets/twit.png" alt="Twitter" className="h-7" />
            </a>
            <a href="https://t.me/TrustifyAI" target="_blank" rel="noopener noreferrer">
              <img src="/assets/telegram.png" alt="Telegram" className="h-6" />
            </a>
          </div>
        </div>

        {/* Footer Links Section */}
        <div className="text-center mt-10">
          <Link to='about' target="_blank" rel="noopener noreferrer" className="mx-3 hover:underline xl:text-lg">About Us</Link>
          <a href="https://policies.google.com/terms?hl=en-US" target="_blank" rel="noopener noreferrer" className="mx-3 hover:underline xl:text-lg">Terms of Service</a>
          <a href="https://trustify-ai-whitepaper.gitbook.io/trustify-docs" target="_blank" rel="noopener noreferrer" className="mx-3 hover:underline xl:text-lg">Docs</a>
        </div>

        {/* Copyright Section */}
        <div className="text-center mt-8 text-xs xl:text-lg">
          <p>&copy; 2025 TrustifyAI. All Rights Reserved.</p>
        </div>
      </div>
    </footer>
  );
}
