import React from 'react';
import NavBar from "./NavBar";
import { Link } from "react-router-dom";


export default function Header() {
  return (
    <div
      className="min-h-screen bg-[#101010] mb-0 items-center w-full overflow-hidden relative"
      id="Header"
    >
      <NavBar />
      
      <div className="flex items-center justify-center bg-gradient-to-r from-[#372FB7] via-[#25216C] to-[#101011] opacity-80 h-[100px] mt-[240px] w-full">
        <p className="text-center text-[17px] md:text-[38px] xl:text-[58px] text-white whitespace-nowrap">
          <span className="font-bold">Revolutionary AI</span>{" "}
          <span className="font-dejaVuSans">for Smarter Investments.</span>
        </p>
      </div>
      <div className="flex flex-col items-center max-w-[750px] m-auto justify-center mt-8">
        <p className="text-gray-300 text-center text-[15px] xl:text-[25.5px] md:text-xl max-w-[90%] sm:max-w-[500px] lg:max-w-[730px] xl:max-w-[1200px] font-light leading-relaxed">
          AI-powered tools for safe and secure crypto and DeFi investments.{" "}
          <br />
          Detect scams, maximize returns, and optimize strategies for smarter
          investments.
        </p>
        <Link
          to='about'
          target="_blank" rel="noopener noreferrer"
          className="text-blue-700 font-bold hover:underline text-[10px] xl:text-[18px] md:text-xl lg:text-[14px] mt-2"
        >
          FIND OUT MORE...
        </Link>
      </div>

      <div className="relative flex items-center justify-center mt-20">
        <img
          src="/assets/pump.png"
          alt="pump pic"
          className="w-full sm:w-[60%] md:w-[70%] lg:w-[50%] xl:w-[780px] h-auto"
        />
        <span
          className="absolute text-gray-400 text-[10px] sm:text-[14px] md:text-[17px] xl:text-[22.5px] 
                   top-[50%] left-1/2 transform -translate-x-1/2 -translate-y-1/2 
                   w-full text-center"
        >
          We are not live yet!
        </span>
      </div>
    </div>
  );
}