import React from "react";
import { Link } from "react-router-dom";

export default function Box() {
  const handleClick = () => {
    // უბრალოდ გამოვაჩინოთ დეფალტური გუგლის პოპ-აპი
    alert("Coming Soon!");
  };

  return (
    <div
      className="py-16 bg-[#101010] text-white grid grid-cols-1 gap-4 md:gap-8"
      id="suite"
    >
      <h2 className="font-heading text-center lg:text-5xl xl:text-[60px] text-5xl font-normal mb-8 text-shadow-lg text-neutral-200 md:text-3xl">
        Our Tools
      </h2>
      {/* First Box */}
      <div className="relative col-span-1 2xl:ml-[560px] border md:mr-1 lg:w-[770px] xl:w-[770px] lg:ml-[230px] xl:ml-[580px] bg-[#131313] border-gray-800 rounded-lg py-16 3xl:ml-[900px] text-white shadow-lg md:p-8 margin-auto-important ">
        <span className="absolute right-[20px] xl:text-[26px] top-[20px] lg:ml-[100px] z-0 hidden p-2 text-[23px] uppercase leading-none text-[#212121] font md:block ">
          COMING SOON
        </span>
        <div className="relative h-[250px] xl:h-[225px] lg:ml-[20px] md:ml[100px] sm:ml-[50px] lg:h-[210px] z-10 flex flex-col border border-neutral-700/80 bg-gradient-to-r from-black via-gray-900 to-indigo-950 py-16 text-white p-6 shadow-lg md:w-4/6">
          <h3 className="mt-[-50px] w-10/12 xl:text-[34px] lg:text-3xl text-[22px] font-dejaVu text-white md:w-full">
            Crypto Scam Detector
          </h3>
          <p className="mb-6 text-neutral-400 mt-[10px] text-sm  xl:text-[18px]">
            The Crypto Scam Detector is an AI-powered tool that analyzes crypto
            projects, transactions, and websites to identify potential scams. It
            detects red flags like rug pulls, phishing sites, and suspicious
            tokenomics, helping users avoid fraudulent investments and stay safe
            in the crypto space.
          </p>
          <div className="absolute flex-col  items-baseline space-y-4 md:flex-row md:space-x-4 md:space-y-0 lg:mr-[50px] ">
            <button
              onClick={handleClick} // აქ მოწვევით გამოვა გუგლის დეფალტური პოპ-აპი
              type="button"
              className="absolute bg-primary-700 py-3 mt-[130px] ml-[-15px] w-[100px] xl:mt-[10px] lg:mt-[-0px] xl:text-[15px] xl:ml-[-17px] lg:top-[105px] lg:ml-[-22px] lg:w-[100px] lg:text-[13px]  font-corisans uppercase text-blue-600 transition-all duration-200 ease-in-out hover:bg-primary-800 focus:outline-none focus:ring-4 focus:ring-primary-300"
            >
              TRY BETA
            </button>
            <div className="absolute">
              <Link
                to="/crypto-scam-detector"
                className="absolute xl:text-[15px] xl:mt-[126px] mt-[125px] ml-[120px] 
                   lg:text-[13px] lg:mt-[117px] lg:ml-[80px] w-[100px]  
                   decoration-animated decoration-primary-600 decoration-2 
                   underline-offset-8 hover:text-primary-600 hover:underline"
                target="_blank"
                rel="noopener noreferrer"
              >
                Read More
                <svg
                  stroke="currentColor"
                  fill="currentColor"
                  strokeWidth="0"
                  viewBox="0 0 16 16"
                  className="ml-[70px] inline-block w-10 mt-[-40px] h-[15px]"
                  height="1em"
                  width="1em"
                  xmlns="http://www.w3.org/2000/svg"
                >
                  <path
                    fillRule="evenodd"
                    d="M1 8a.5.5 0 0 1 .5-.5h11.793l-3.147-3.146a.5.5 0 0 1 .708-.708l4 4a.5.5 0 0 1 0 .708l-4 4a.5.5 0 0 1-.708-.708L13.293 8.5H1.5A.5.5 0 0 1 1 8z"
                  ></path>
                </svg>
              </Link>
            </div>
          </div>
        </div>
      </div>

      {/* Second Box */}
      <div className="relative col-span-1 3xl:ml-[900px] 2xl:ml-[560px] border xl:h-[350px] lg:w-[770px]  lg:h-[310px] lg:ml-[230px]  xl:w-[770px] xl:ml-[580px] bg-[#131313] border-gray-800 rounded-lg py-16 text-white shadow-lg md:p-8 margin-auto-important ">
        <span className="absolute right-[20px] xl:text-[26px] top-[20px] lg:ml-[100px] z-0 hidden p-2 text-[23px] uppercase leading-none text-[#212121] font md:block ">
          COMING SOON
        </span>
        <div className="relative xl:h-[270px] lg:ml-[20px] md:ml[100px] sm:ml-[50px] lg:h-[250px] h-[300px] z-10 flex flex-col border border-neutral-700/80 bg-gradient-to-r from-black via-gray-900 to-indigo-950 py-16 text-white p-6 shadow-lg md:w-4/6">
          <h3 className="mt-[-50px] w-10/12 xl:text-[34px] lg:text-3xl text-[22px] font-dejaVu text-white md:w-full">
            DeFi Strategy Advisor
          </h3>
          <p className="mb-6 text-neutral-400 mt-[10px] text-sm xl:text-[18px]">
            An AI-powered DeFi (Decentralized Finance) Strategy Advisor that
            helps users optimize their DeFi investments by suggesting
            personalized strategies based on their financial goals, risk
            tolerance, and current market conditions. The tool would integrate
            with popular DeFi protocols, monitor market movements in real-time,
            and provide actionable insights to maximize returns and minimize
            risks.
          </p>
          <div className="absolute flex-col items-baseline space-y-4 md:flex-row md:space-x-4 md:space-y-0 lg:mr-[100px]">
            <button
              onClick={handleClick} // აქაც გამოვა დეფალტური პოპ-აპი
              type="button"
              className="bg-primary-700 py-3 mt-[180px] lg:mt-[145px] xl:mt-[155px] lg:text-[13px] xl:text-[15px] font-corisans uppercase text-blue-600 transition-all duration-200 ease-in-out hover:bg-primary-500 focus:outline"
            >
              TRY BETA
            </button>
            <div>
              <Link
                to="/defi-strategy-advisor"
                className="absolute decoration-animated w-20 mt-[-53px] ml-[120px] xl:text-[15px] xl:mt-[-35px]  lg:mt-[-32px] lg:ml-[80px] lg:text-[13px] decoration-primary-600 decoration-2 underline-offset-8 hover:text-primary-600 hover:underline"
                target="_blank"
                rel="noopener noreferrer"
              >
                Read More
                <svg
                    stroke="currentColor"
                    fill="currentColor"
                    strokeWidth="0"
                    viewBox="0 0 16 16"
                    className="ml-[70px] inline-block w-10 h-[15px] sm:w-8 sm:h-[12px] md:w-10 md:h-[15px] lg:w-12 lg:h-[18px] mt-[-40px]"
                    height="1em"
                    width="1em"
                    xmlns="http://www.w3.org/2000/svg"
                  >

                  <path
                    fillRule="evenodd"
                    d="M1 8a.5.5 0 0 1 .5-.5h11.793l-3.147-3.146a.5.5 0 0 1 .708-.708l4 4a.5.5 0 0 1 0 .708l-4 4a.5.5 0 0 1-.708-.708L13.293 8.5H1.5A.5.5 0 0 1 1 8z"
                  ></path>
                </svg>
              </Link>
            </div>
          </div>
        </div>
      </div>
    </div>
  );
}
