import React from "react";

export default function ReadMorePage() {
  return (
    <div className="flex items-center justify-center bg-black text-white p-6 min-h-screen">
      <div className="border border-gray-700 p-8 max-w-xl text-left rounded-lg shadow-lg">
        <h1 className="text-4xl font-semibold mt-6 mb-3">Crypto Scam Detector Tool</h1>
        <p className="text-lg mb-4">
          The Crypto Scam Detector is an advanced AI-powered tool designed to protect cryptocurrency investors from falling victim to scams, frauds, and market manipulation. It analyzes crypto projects, websites, smart contracts, social media activity, and transaction behavior to detect potential scams.
        </p>

        <h2 className="text-2xl font-semibold mt-6 mb-3">Key Features:</h2>
        <ul className="space-y-3">
          <li><strong>Risk Scoring System:</strong> Assigns a risk score to cryptocurrency projects based on factors like transparency, team credibility, whitepaper analysis, tokenomics, and social media activity.</li>
          <li><strong>Smart Contract & Tokenomics Analysis:</strong> Scans smart contracts for vulnerabilities and evaluates token distribution to detect potential rug pulls.</li>
          <li><strong>Social Media & Sentiment Analysis:</strong> Uses NLP to monitor social media platforms, detect exaggerated claims, and identify untrustworthy influencers.</li>
          <li><strong>Phishing Website Detection:</strong> Scans crypto-related websites for phishing attempts, fraudulent SSL certificates, and domain legitimacy.</li>
          <li><strong>Real-Time Alerts & Notifications:</strong> Sends instant alerts on suspicious activities via email, SMS, or Telegram.</li>
          <li><strong>Community Reputation Monitoring:</strong> Aggregates user feedback to analyze sentiment and identify scam reports.</li>
          <li><strong>ICO/IDO & Token Sale Evaluation:</strong> Examines new token sales for red flags like anonymous teams and vague whitepapers.</li>
          <li><strong>Blockchain Explorer Integration:</strong> Tracks suspicious wallet addresses and flags high-risk addresses.</li>
          <li><strong>Historical Scam Database:</strong> Compares new projects with past scams to detect fraudulent patterns.</li>
          <li><strong>Educational Resources:</strong> Provides learning materials to help users recognize and avoid scams.</li>
        </ul>

        <h2 className="text-2xl font-semibold mt-6 mb-3">Membership Plan for Token Holders:</h2>
        <ul className="space-y-3">
          <li><strong>Free Access:</strong> Users holding 500,000+ Trustify tokens get free access to all features.</li>
          <li><strong>Paid Access:</strong> Users with fewer than 500 Trustify tokens can purchase access using the Trustify token.</li>
          <li><strong>Token Utility:</strong> Trustify tokens are used for payments, scam reporting incentives, and ecosystem sustainability.</li>
          <li><strong>Premium Features:</strong> High-tier token holders receive exclusive reports, deeper evaluations, and early access to updates.</li>
        </ul>
      </div>
    </div>
  );
}
