import React from 'react';

export default function ReadMorePage() {
  return (
    <div className="flex items-center justify-center min-h-screen bg-black text-white p-6">
      <div className="border border-gray-700 p-6 max-w-xl text-left">
        <h1 className="text-4xl font-semibold mt-6 mb-3">DeFi Strategy Advisor Tool</h1>
        <p className="text-lg mb-4">
          The DeFi Strategy Advisor is a powerful AI-driven platform designed to help cryptocurrency investors optimize their decentralized finance (DeFi) investments. By leveraging advanced machine learning and real-time market analysis, the tool provides personalized investment strategies tailored to each user's risk tolerance, financial goals, and current market conditions. Whether users are looking to maximize passive income, diversify their portfolios, or minimize risk, the DeFi Strategy Advisor offers actionable insights to help them navigate the complex and evolving world of DeFi.
        </p>

        <h2 className="text-2xl font-semibold mt-6 mb-3">Key Features:</h2>
        <ul className="space-y-3">
          <li><strong>Personalized Investment Strategy:</strong> Creates a customized plan based on the user's risk profile and financial goals.</li>
          <li><strong>Multi-Protocol Recommendations:</strong> Suggests investments across top DeFi platforms like Aave, Uniswap, and SushiSwap.</li>
          <li><strong>Real-Time Market Monitoring & Analytics:</strong> Tracks market trends, protocol performance, and yield farming opportunities.</li>
          <li><strong>Risk Assessment & Portfolio Optimization:</strong> Evaluates platform security, token volatility, and smart contract reliability.</li>
          <li><strong>Dynamic Auto-Rebalancing:</strong> Adjusts portfolios automatically to optimize yield and reduce risks.</li>
          <li><strong>Impermanent Loss Protection:</strong> Identifies low-risk liquidity pools to minimize impermanent loss.</li>
          <li><strong>DeFi Security & Smart Contract Audits:</strong> Integrates with services like Certik to detect vulnerabilities in protocols.</li>
          <li><strong>Tax Optimization for DeFi Earnings:</strong> Provides insights on tax-efficient strategies and generates tax reports.</li>
          <li><strong>Educational Content & Strategy Guides:</strong> Offers personalized learning materials on DeFi investment strategies.</li>
          <li><strong>Yield Comparison & Performance Tracking:</strong> Helps users compare returns across different DeFi platforms.</li>
        </ul>

        <h2 className="text-2xl font-semibold mt-6 mb-3">Benefits:</h2>
        <ul className="space-y-3">
          <li><strong>Optimized DeFi Investments:</strong> Tailored strategies for maximizing returns while managing risk.</li>
          <li><strong>Real-Time Analytics & Auto-Rebalancing:</strong> AI-driven portfolio adjustments based on market conditions.</li>
          <li><strong>Enhanced Security:</strong> Smart contract audits and vulnerability assessments reduce the risk of financial loss.</li>
          <li><strong>Tax Efficiency:</strong> Tools to optimize tax implications and simplify reporting.</li>
          <li><strong>Education & Growth:</strong> Users gain in-depth DeFi knowledge tailored to their portfolios.</li>
        </ul>
      </div>
    </div>
  );
}
