import React from "react";

const teamMembers = [
  {
    name: "Giorgi Giglemiani",
    title: "Founder/CEO",
    bio: (
      <p>
        Graduated from London Business School with a degree in
        Business/Marketing.
        <br />
        Motto - "Unlocking Tomorrow with AI."
      </p>
    ),
    image: "/assets/profileee.png",
  },

  {
    name: "Harish Joshi",
    title: "Head of Marketing",
    bio: "Harish develops strategies to promote AI products, driving brand awareness and customer engagement through creative campaigns and digital marketing.",
    image: "/assets/logo.png",
  },
  {
    name: "Kieran",
    title: "Solidity/Full Stack Developer",
    bio: "I'm just a Solidity Developer...",
    image: "/assets/logo.png",
  },
];

const TeamSection = () => {
  return (
    <section className="py-16 bg-[#101010] text-white" id="team">
      <div className="container mx-auto text-center">
        <h2 className="text-5xl xl:text-[58px] font-normal mb-8 text-shadow-lg">
          Meet Our Team
        </h2>
        <p className="text-lg mb-12 opacity-80 xl:text-[25.5px]">
          A group of dedicated professionals building the future of AI.
        </p>
        <div className="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 gap-8 mx-auto">
          {teamMembers.map((member, index) => (
            <div
              key={index}
              className="bg-gradient-to-r bg-[#101010]   text-gray-100 shadow-2xl w-[300px] rounded-xl p-6 hover:shadow-3xl transition-shadow border border-gray-700 mx-auto"
            >
              <img
                src={member.image}
                alt={member.name}
                className="w-24 h-24 mx-auto rounded-full mb-4 border-2 border-indigo-300"
              />
              <h3 className="text-xl font-extrabold text-shadow-md xl:text-[22px]">
                {member.name}
              </h3>
              <p className="text-sm text-gray-300 text-DejaVuSans xl:text-[19px]">
                {member.title}
              </p>
              <p className="mb-6 text-neutral-400 mt-[10px] xl:text-[18px] text-sm">
                {member.bio}
              </p>
            </div>
          ))}
        </div>
      </div>
    </section>
  );
};

export default TeamSection;
